'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReduxSemaphore = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactReduxRestate = require('react-redux-restate');

var _reactReduxRestate2 = _interopRequireDefault(_reactReduxRestate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SECRET = '__semaphore_secret';
var RenderChildren = function RenderChildren(_ref) {
  var children = _ref.children;
  return children;
};

var semaphore = function semaphore(shouldApplyState) {
  return function (WrappedComponent) {
    return (0, _reactReduxRestate2.default)({}, function (stores, props) {
      return shouldApplyState(stores.default, props) ? stores.default : undefined;
    }, function (dispatchers, event) {
      return dispatchers.default(event);
    }, function () {
      return {
        ignoreProps: [SECRET, 'condition', 'componentProps']
      };
    })(WrappedComponent);
  };
};

// Component model
var ComponentSemaphore = semaphore(function (store, props) {
  return props[SECRET].condition(store, props);
})(RenderChildren);

var semaphoreSecret = _defineProperty({}, SECRET, {
  condition: function condition(stores, props) {
    return props.condition(stores, props.componentProps);
  }
});

var simpleLock = function simpleLock(stores, props) {
  return !props.locked;
};

var ReduxSemaphore = function ReduxSemaphore(_ref2) {
  var _ref2$condition = _ref2.condition,
      condition = _ref2$condition === undefined ? simpleLock : _ref2$condition,
      children = _ref2.children,
      rest = _objectWithoutProperties(_ref2, ['condition', 'children']);

  return _react2.default.createElement(
    ComponentSemaphore,
    _extends({}, semaphoreSecret, { condition: condition, componentProps: rest }),
    children
  );
};

ReduxSemaphore.propTypes = {
  condition: _propTypes2.default.func,
  children: _propTypes2.default.node,
  locked: _propTypes2.default.bool
};

exports.ReduxSemaphore = ReduxSemaphore;
exports.default = semaphore;